﻿namespace UltraGridBindingListAddNewRow
{
    using System;
    using System.ComponentModel;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        private BindingList<Person> _list = new BindingList<Person>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitializeBindingList();
            ultraGrid1.DisplayLayout.Override.AllowAddNew = Infragistics.Win.UltraWinGrid.AllowAddNew.TemplateOnBottom;
        }

        private void InitializeBindingList()
        {
            _list.Add(new Person("Johny", "Bravo", 33));
            _list.Add(new Person("George", "Michael", 59));
            _list.Add(new Person("Tommy", "Cat", 78));
            _list.Add(new Person("Steven", "Spielberg", 69));
            _list.Add(new Person("Jose", "Morales", 22));
            _list.Add(new Person("Ivan", "Dimitrov", 50));
            _list.Add(new Person("Sam", "Devine", 26));

            var bindingSource = new BindingSource(_list, string.Empty);
            ultraGrid1.DataSource = bindingSource;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MessageBox.Show(_list.Count.ToString());
        }
    }

    public class Person
    {
        public int Age { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }

        // The parameterless constructor is essential, 
        // otherwise "Row insertion is not supported by this data source" will be thrown
        // when the user tries to add new row.
        public Person()
        {
        }

        public Person(string firstName, string lastName, int age)
        {
            Age = age;
            FirstName = firstName;
            LastName = lastName;
        }
    }
}
